(define (domain CrewPlanning)
(:requirements :typing :fluents :action-costs )
(:types
	MedicalState - objects
	FilterState - objects
	CrewMember - objects
	PayloadAct - objects
	Day - objects
	RPCM - objects
	softgoalorder
)
(:predicates
	(mcs_finished ?ps - MedicalState ?d - Day )
	(changed ?fs - FilterState ?d - Day )
	(done_meal ?c - CrewMember ?d - Day )
	(done_exercise ?c - CrewMember ?d - Day )
	(not_sleeping ?c - CrewMember )
	(done_first_reconfigure_thermal_loop ?r - RPCM )
	(done_remove_sleep_station ?r - RPCM )
	(done_replace_rpcm ?r - RPCM )
	(done_assemble_sleep_station ?r - RPCM )
	(done_second_reconfigurate_thermal_loops ?r - RPCM )
	(done_rpcm ?r - RPCM )
	(payload_act_completed ?pa - PayloadAct )
	(currentday ?d - Day )
	(active ?c - CrewMember ?d - day )
	(next ?d1 - Day ?d2 - Day )
	(next-softgoal ?v0 - softgoalorder ?v1 - softgoalorder )
	(current-softgoal ?v0 - softgoalorder )
	(normal-mode )
	(softgoal-mode )
	(changed-softgoal ?v0 - FilterState ?v1 - Day )
	(changed-softgoal-order ?v0 - FilterState ?v1 - Day ?v2 - softgoalorder )
	(currentday-softgoal ?v0 - Day )
	(currentday-softgoal-order ?v0 - Day ?v1 - softgoalorder )
	(mcs_finished-softgoal ?v0 - MedicalState ?v1 - Day )
	(mcs_finished-softgoal-order ?v0 - MedicalState ?v1 - Day ?v2 - softgoalorder )
	(done_rpcm-softgoal ?v0 - RPCM )
	(done_rpcm-softgoal-order ?v0 - RPCM ?v1 - softgoalorder )
)
(:functions
	(available_time ?c - CrewMember ?d - Day )
	(crew_efficiency ?c - CrewMember ?d - Day )
	(achieve_time_discount ?d - Day )
	(payloadact_length ?pa - PayloadAct )
	(total-cost )
	(changed-softgoal-reward ?v0 - FilterState ?v1 - Day )
	(currentday-softgoal-reward ?v0 - Day )
	(mcs_finished-softgoal-reward ?v0 - MedicalState ?v1 - Day )
	(done_rpcm-softgoal-reward ?v0 - RPCM )
)
(:action move_to_next_day
	:parameters (?d1 - Day ?d2 - Day )
	:precondition (and
		(currentday ?d1 )
		(next ?d1 ?d2 )
		(forall (?c - CrewMember  )
(not (active ?c ?d1 )))

		(normal-mode )
)
	:effect (and
		(not (currentday ?d1 ))
		(currentday ?d2 )
)
)

(:action post_sleep
	:parameters (?c - CrewMember ?d - Day )
	:precondition (and
		(currentday ?d )
		(>= (available_time ?c ?d )195)
		(normal-mode )
)
	:effect (and
		(not_sleeping ?c )
		(increase (total-cost ) 195 )
		(decrease (available_time ?c ?d ) 195 )
)
)

(:action have_meal
	:parameters (?c - CrewMember ?d - Day )
	:precondition (and
		(currentday ?d )
		(not_sleeping ?c )
		(>= (available_time ?c ?d )60)
		(normal-mode )
)
	:effect (and
		(done_meal ?c ?d )
		(increase (total-cost ) 60 )
		(decrease (available_time ?c ?d ) 60 )
)
)

(:action exercise
	:parameters (?c - CrewMember ?d - Day )
	:precondition (and
		(currentday ?d )
		(not_sleeping ?c )
		(>= (available_time ?c ?d )60)
		(normal-mode )
)
	:effect (and
		(done_exercise ?c ?d )
		(increase (total-cost ) 60 )
		(decrease (available_time ?c ?d ) 60 )
)
)

(:action sleep
	:parameters (?c - CrewMember ?d - Day )
	:precondition (and
		(currentday ?d )
		(not_sleeping ?c )
		(done_exercise ?c ?d )
		(done_meal ?c ?d )
		(>= (available_time ?c ?d )600)
		(normal-mode )
)
	:effect (and
		(not (active ?c ?d ))
		(not (not_sleeping ?c ))
		(increase (total-cost ) 600 )
		(decrease (available_time ?c ?d ) 600 )
)
)

(:action change_filter
	:parameters (?fs - FilterState ?c - CrewMember ?d - Day )
	:precondition (and
		(currentday ?d )
		(not_sleeping ?c )
		(>= (available_time ?c ?d )60)
		(normal-mode )
)
	:effect (and
		(changed ?fs ?d )
		(increase (total-cost ) (* 6 (crew_efficiency ?c ?d )) )
		(decrease (available_time ?c ?d ) 60 )
)
)

(:action medical_conference
	:parameters (?ps - MedicalState ?c - CrewMember ?d - Day )
	:precondition (and
		(currentday ?d )
		(not_sleeping ?c )
		(>= (available_time ?c ?d )60)
		(normal-mode )
)
	:effect (and
		(mcs_finished ?ps ?d )
		(increase (total-cost ) 60 )
		(decrease (available_time ?c ?d ) 60 )
)
)

(:action conduct_payload_activity
	:parameters (?pa - PayloadAct ?c - CrewMember ?d - Day )
	:precondition (and
		(currentday ?d )
		(not_sleeping ?c )
		(>= (available_time ?c ?d )(payloadact_length ?pa ))
		(normal-mode )
)
	:effect (and
		(payload_act_completed ?pa )
		(increase (total-cost ) (* (/ (payloadact_length ?pa ) 10) (+ (crew_efficiency ?c ?d ) (achieve_time_discount ?d ))) )
		(decrease (available_time ?c ?d ) (payloadact_length ?pa ) )
)
)

(:action first_reconfigurate_thermal_loops
	:parameters (?r - RPCM ?c - CrewMember ?d - Day )
	:precondition (and
		(>= (available_time ?c ?d )60)
		(not_sleeping ?c )
		(currentday ?d )
		(normal-mode )
)
	:effect (and
		(done_first_reconfigure_thermal_loop ?r )
		(increase (total-cost ) (* 6 (crew_efficiency ?c ?d )) )
		(decrease (available_time ?c ?d ) 60 )
)
)

(:action remove_sleep_station
	:parameters (?r - RPCM ?c - CrewMember ?d - Day )
	:precondition (and
		(>= (available_time ?c ?d )60)
		(not_sleeping ?c )
		(currentday ?d )
		(normal-mode )
)
	:effect (and
		(done_remove_sleep_station ?r )
		(increase (total-cost ) (* 6 (crew_efficiency ?c ?d )) )
		(decrease (available_time ?c ?d ) 60 )
)
)

(:action replace_rpcm
	:parameters (?r - RPCM ?c - CrewMember ?d - Day )
	:precondition (and
		(>= (available_time ?c ?d )180)
		(not_sleeping ?c )
		(currentday ?d )
		(done_first_reconfigure_thermal_loop ?r )
		(done_remove_sleep_station ?r )
		(normal-mode )
)
	:effect (and
		(done_replace_rpcm ?r )
		(increase (total-cost ) (* 18 (crew_efficiency ?c ?d )) )
		(decrease (available_time ?c ?d ) 180 )
)
)

(:action assemble_sleep_station
	:parameters (?r - RPCM ?c - CrewMember ?d - Day )
	:precondition (and
		(>= (available_time ?c ?d )60)
		(not_sleeping ?c )
		(currentday ?d )
		(done_replace_rpcm ?r )
		(normal-mode )
)
	:effect (and
		(done_assemble_sleep_station ?r )
		(increase (total-cost ) (* 6 (crew_efficiency ?c ?d )) )
		(decrease (available_time ?c ?d ) 60 )
)
)

(:action second_reconfigurate_thermal_loops
	:parameters (?r - RPCM ?c - CrewMember ?d - Day )
	:precondition (and
		(>= (available_time ?c ?d )60)
		(not_sleeping ?c )
		(currentday ?d )
		(done_replace_rpcm ?r )
		(normal-mode )
)
	:effect (and
		(done_second_reconfigurate_thermal_loops ?r )
		(increase (total-cost ) (* 6 (crew_efficiency ?c ?d )) )
		(decrease (available_time ?c ?d ) 60 )
)
)

(:action finish_rpcm
	:parameters (?r - RPCM ?d - Day )
	:precondition (and
		(currentday ?d )
		(done_second_reconfigurate_thermal_loops ?r )
		(done_assemble_sleep_station ?r )
		(normal-mode )
)
	:effect (and
		(done_rpcm ?r )
		(increase (total-cost ) (* 20 (achieve_time_discount ?d )) )
)
)

(:action changed-softgoal-collect
	:parameters (?v0 - FilterState ?v1 - Day ?v2 - softgoalorder ?v3 - softgoalorder )
	:precondition (and
		(next-softgoal ?v2 ?v3 )
		(current-softgoal ?v2 )
		(changed-softgoal-order ?v0 ?v1 ?v2 )
		(softgoal-mode )
		(changed ?v0 ?v1 )
)
	:effect (and
		(changed-softgoal ?v0 ?v1 )
		(current-softgoal ?v3 )
		(not (current-softgoal ?v2 ))
)
)

(:action changed-softgoal-forgo
	:parameters (?v0 - FilterState ?v1 - Day ?v2 - softgoalorder ?v3 - softgoalorder )
	:precondition (and
		(softgoal-mode )
		(next-softgoal ?v2 ?v3 )
		(current-softgoal ?v2 )
		(changed-softgoal-order ?v0 ?v1 ?v2 )
		(not (changed ?v0 ?v1 ))
)
	:effect (and
		(changed-softgoal ?v0 ?v1 )
		(current-softgoal ?v3 )
		(not (current-softgoal ?v2 ))
		(increase (total-cost ) (changed-softgoal-reward ?v0 ?v1 ) )
)
)

(:action currentday-softgoal-collect
	:parameters (?v0 - Day ?v1 - softgoalorder ?v2 - softgoalorder )
	:precondition (and
		(next-softgoal ?v1 ?v2 )
		(current-softgoal ?v1 )
		(currentday-softgoal-order ?v0 ?v1 )
		(softgoal-mode )
		(currentday ?v0 )
)
	:effect (and
		(currentday-softgoal ?v0 )
		(current-softgoal ?v2 )
		(not (current-softgoal ?v1 ))
)
)

(:action currentday-softgoal-forgo
	:parameters (?v0 - Day ?v1 - softgoalorder ?v2 - softgoalorder )
	:precondition (and
		(softgoal-mode )
		(next-softgoal ?v1 ?v2 )
		(current-softgoal ?v1 )
		(currentday-softgoal-order ?v0 ?v1 )
		(not (currentday ?v0 ))
)
	:effect (and
		(currentday-softgoal ?v0 )
		(current-softgoal ?v2 )
		(not (current-softgoal ?v1 ))
		(increase (total-cost ) (currentday-softgoal-reward ?v0 ) )
)
)

(:action mcs_finished-softgoal-collect
	:parameters (?v0 - MedicalState ?v1 - Day ?v2 - softgoalorder ?v3 - softgoalorder )
	:precondition (and
		(next-softgoal ?v2 ?v3 )
		(current-softgoal ?v2 )
		(mcs_finished-softgoal-order ?v0 ?v1 ?v2 )
		(softgoal-mode )
		(mcs_finished ?v0 ?v1 )
)
	:effect (and
		(mcs_finished-softgoal ?v0 ?v1 )
		(current-softgoal ?v3 )
		(not (current-softgoal ?v2 ))
)
)

(:action mcs_finished-softgoal-forgo
	:parameters (?v0 - MedicalState ?v1 - Day ?v2 - softgoalorder ?v3 - softgoalorder )
	:precondition (and
		(softgoal-mode )
		(next-softgoal ?v2 ?v3 )
		(current-softgoal ?v2 )
		(mcs_finished-softgoal-order ?v0 ?v1 ?v2 )
		(not (mcs_finished ?v0 ?v1 ))
)
	:effect (and
		(mcs_finished-softgoal ?v0 ?v1 )
		(current-softgoal ?v3 )
		(not (current-softgoal ?v2 ))
		(increase (total-cost ) (mcs_finished-softgoal-reward ?v0 ?v1 ) )
)
)

(:action done_rpcm-softgoal-collect
	:parameters (?v0 - RPCM ?v1 - softgoalorder ?v2 - softgoalorder )
	:precondition (and
		(next-softgoal ?v1 ?v2 )
		(current-softgoal ?v1 )
		(done_rpcm-softgoal-order ?v0 ?v1 )
		(softgoal-mode )
		(done_rpcm ?v0 )
)
	:effect (and
		(done_rpcm-softgoal ?v0 )
		(current-softgoal ?v2 )
		(not (current-softgoal ?v1 ))
)
)

(:action done_rpcm-softgoal-forgo
	:parameters (?v0 - RPCM ?v1 - softgoalorder ?v2 - softgoalorder )
	:precondition (and
		(softgoal-mode )
		(next-softgoal ?v1 ?v2 )
		(current-softgoal ?v1 )
		(done_rpcm-softgoal-order ?v0 ?v1 )
		(not (done_rpcm ?v0 ))
)
	:effect (and
		(done_rpcm-softgoal ?v0 )
		(current-softgoal ?v2 )
		(not (current-softgoal ?v1 ))
		(increase (total-cost ) (done_rpcm-softgoal-reward ?v0 ) )
)
)

(:action begin-softgoal-mode
	:parameters ()
	:precondition (and
		(normal-mode )
)
	:effect (and
		(not (normal-mode ))
		(softgoal-mode )
)
)

)
