(define (domain openstacks-netbenefit-ADL)
(:requirements :typing :adl :action-costs )
(:types
	order
	product
	count
	softgoalorder
)
(:predicates
	(includes ?o - order ?p - product )
	(waiting ?o - order )
	(started ?o - order )
	(shipped ?o - order )
	(made ?p - product )
	(delivered ?o - order ?p - product )
	(stacks-avail ?s - count )
	(next-count ?s - count ?ns - count )
	(next-softgoal ?v0 - softgoalorder ?v1 - softgoalorder )
	(current-softgoal ?v0 - softgoalorder )
	(normal-mode )
	(softgoal-mode )
	(delivered-softgoal ?v0 - order ?v1 - product )
	(delivered-softgoal-order ?v0 - order ?v1 - product ?v2 - softgoalorder )
)
(:functions
	(total-cost )
	(stack-cost )
	(delivered-softgoal-reward ?v0 - order ?v1 - product )
)
(:action open-new-stack
	:parameters (?open - count ?new-open - count )
	:precondition (and
		(stacks-avail ?open )
		(next-count ?open ?new-open )
		(normal-mode )
)
	:effect (and
		(not (stacks-avail ?open ))
		(stacks-avail ?new-open )
		(increase (total-cost ) (stack-cost ) )
)
)

(:action start-order
	:parameters (?o - order ?avail - count ?new-avail - count )
	:precondition (and
		(waiting ?o )
		(stacks-avail ?avail )
		(next-count ?new-avail ?avail )
		(normal-mode )
)
	:effect (and
		(not (waiting ?o ))
		(started ?o )
		(not (stacks-avail ?avail ))
		(stacks-avail ?new-avail )
)
)

(:action make-product
	:parameters (?p - product )
	:precondition (and
		(not (made ?p ))
		(normal-mode )
)
	:effect (and
		(made ?p )
		(forall (?o - order  )
(when
(and
		(includes ?o ?p )
		(started ?o )
)
(delivered ?o ?p ))
)

)
)

(:action ship-order
	:parameters (?o - order ?avail - count ?new-avail - count )
	:precondition (and
		(started ?o )
		(stacks-avail ?avail )
		(next-count ?avail ?new-avail )
		(normal-mode )
)
	:effect (and
		(not (started ?o ))
		(shipped ?o )
		(not (stacks-avail ?avail ))
		(stacks-avail ?new-avail )
)
)

(:action delivered-softgoal-collect
	:parameters (?v0 - order ?v1 - product ?v2 - softgoalorder ?v3 - softgoalorder )
	:precondition (and
		(next-softgoal ?v2 ?v3 )
		(current-softgoal ?v2 )
		(delivered-softgoal-order ?v0 ?v1 ?v2 )
		(softgoal-mode )
		(delivered ?v0 ?v1 )
)
	:effect (and
		(delivered-softgoal ?v0 ?v1 )
		(current-softgoal ?v3 )
		(not (current-softgoal ?v2 ))
)
)

(:action delivered-softgoal-forgo
	:parameters (?v0 - order ?v1 - product ?v2 - softgoalorder ?v3 - softgoalorder )
	:precondition (and
		(softgoal-mode )
		(next-softgoal ?v2 ?v3 )
		(current-softgoal ?v2 )
		(delivered-softgoal-order ?v0 ?v1 ?v2 )
		(not (delivered ?v0 ?v1 ))
)
	:effect (and
		(delivered-softgoal ?v0 ?v1 )
		(current-softgoal ?v3 )
		(not (current-softgoal ?v2 ))
		(increase (total-cost ) (delivered-softgoal-reward ?v0 ?v1 ) )
)
)

(:action begin-softgoal-mode
	:parameters ()
	:precondition (and
		(normal-mode )
)
	:effect (and
		(not (normal-mode ))
		(softgoal-mode )
)
)

)
