(define (domain pegsolitaire-netbenefit)
(:requirements :typing :action-costs )
(:types
	location - object
	softgoalorder
)
(:predicates
	(IN-LINE ?x - location ?y - location ?z - location )
	(occupied ?l - location )
	(free ?l - location )
	(next-softgoal ?v0 - softgoalorder ?v1 - softgoalorder )
	(current-softgoal ?v0 - softgoalorder )
	(normal-mode )
	(softgoal-mode )
	(free-softgoal ?v0 - location )
	(free-softgoal-order ?v0 - location ?v1 - softgoalorder )
)
(:functions
	(total-cost )
	(free-softgoal-reward ?v0 - location )
)
(:action jump
	:parameters (?from - location ?over - location ?to - location )
	:precondition (and
		(IN-LINE ?from ?over ?to )
		(occupied ?from )
		(occupied ?over )
		(free ?to )
		(normal-mode )
)
	:effect (and
		(not (occupied ?from ))
		(not (occupied ?over ))
		(not (free ?to ))
		(free ?from )
		(free ?over )
		(occupied ?to )
)
)

(:action free-softgoal-collect
	:parameters (?v0 - location ?v1 - softgoalorder ?v2 - softgoalorder )
	:precondition (and
		(next-softgoal ?v1 ?v2 )
		(current-softgoal ?v1 )
		(free-softgoal-order ?v0 ?v1 )
		(softgoal-mode )
		(free ?v0 )
)
	:effect (and
		(free-softgoal ?v0 )
		(current-softgoal ?v2 )
		(not (current-softgoal ?v1 ))
)
)

(:action free-softgoal-forgo
	:parameters (?v0 - location ?v1 - softgoalorder ?v2 - softgoalorder )
	:precondition (and
		(softgoal-mode )
		(next-softgoal ?v1 ?v2 )
		(current-softgoal ?v1 )
		(free-softgoal-order ?v0 ?v1 )
		(not (free ?v0 ))
)
	:effect (and
		(free-softgoal ?v0 )
		(current-softgoal ?v2 )
		(not (current-softgoal ?v1 ))
		(increase (total-cost ) (free-softgoal-reward ?v0 ) )
)
)

(:action begin-softgoal-mode
	:parameters ()
	:precondition (and
		(normal-mode )
)
	:effect (and
		(not (normal-mode ))
		(softgoal-mode )
)
)

)
